routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

// TODO : user not connected
Route::post('/users/{user}/finish', 'UsersController@storeFinish')->name('users.finish');
Route::get('/users/{user}/finish', 'UsersController@finish');

/* User connected */
Route::middleware(['auth'])->group(function () {
    Route::get('/', 'HomeController@index');

    Route::resource('probes', 'ProbesController')->only(['index', 'show']);
    Route::resource('plants', 'PlantsController')->only(['index', 'show']);
});

/* Admin */
Route::middleware(['auth', 'admin'])->group(function () {
    Route::resource('users', 'UsersController')->only(['index', 'store']);
    Route::resource('probes', 'ProbesController')->only(['store']);
    Route::resource('plants', 'PlantsController')->only(['store', 'destroy']);
});

app/Probe.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Probe extends Model
{

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'type'
    ];


    /**
     * Get probes of user.
     */
    public function data()
    {
        return $this->hasMany('App\ProbeData')->orderBy('created_at');
    }
}

app/Http/Controllers/Api/ProbesController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Probe;
use Illuminate\Http\Request;

class ProbesController extends Controller
{
    public function getData(Request $request, Probe $probe){
        $data = $probe->data()
            ->whereDate('created_at', '>=', $request->query('startDate'))
            ->whereDate('created_at', '<=', $request->query('endDate'))
            ->orderBy('created_at')
            ->get();

        // Treat data

        $labels = [];
        $temperature = [];
        $humidity = [];

        // Si la date séléctionné = 1 jour
        if(date('Ymd', strtotime ($request->query('startDate'))) == date('Ymd', strtotime($request->query('endDate')))){
            foreach ($data as $row){
                array_push($labels, $row->created_at->format('H:i'));
                array_push($temperature, $row->temperature);
                array_push($humidity, $row->humidity);
            }
        }
        // Si la date séléctionné > 1 jour
        else{
            $grouped = $data->groupBy(function ($item, $key) {
                return $item->created_at->format('d-m-Y');
            });

            foreach ($grouped as $key => $date){
                array_push($labels, $key);
                array_push($temperature, round($date->avg('temperature'), 2));
                array_push($humidity, round($date->avg('humidity'), 2));
            }
        }

        $result = [
            'labels' => $labels,
            'temperature' => $temperature,
            'humidity' => $humidity,
        ];

        return response($result);
    }
}

app/Http/Controllers/ProbesController.php
<?php

namespace App\Http\Controllers;

use App\Probe;
use App\ProbeData;
use Carbon\Carbon;
use Illuminate\Http\Request;

class ProbesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $probes = Probe::all();
        return view('probes.index', compact('probes'));
    }

    public function store(Request $request)
    {
        $probe = Probe::create([
            'name' => $request->name,
            'type' => $request->type,
        ]);

        if ($request->has('add-test-data')) {
            $dateStart = Carbon::now()->hour(0)->subMonths(1);
            $dateEnd = Carbon::now();

            while ($dateStart->lessThan($dateEnd)) {
                ProbeData::create([
                    'probe_id' => $probe->id,
                    'temperature' => rand(-10, 45),
                    'humidity' => rand(0, 100),
                    'created_at' => $dateStart
                ]);
                $dateStart->addHour();
            }
        }

        return redirect(route('probes.index'))->with('success', "Capteur créé avec succès !");
    }

    /**
     * @param Probe $probe
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Probe $probe)
    {
        return view('probes.view', compact('probe'));
    }
}

resources/views/probes/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="card card-primary">
        <div class="card-header">
            <h3 class="card-title">Créer un capteur</h3>
        </div>
        <!-- /.card-header -->
        <!-- form start -->
        <form method="POST" action="{{ route('probes.store') }}">
            @csrf

            <div class="card-body">

                <div class="form-group">
                    <label for="email">Name</label>
                    <input type="text" name="name" id="name"
                           class="form-control @error('name') is-invalid @enderror" placeholder="Enter name"
                           value="{{ old('name') }}" required>
                    @error('name')
                    <span class="invalid-feedback" role="alert">
                        <strong>{{ $message }}</strong>
                    </span>
                    @enderror
                </div>

                <div class="form-group">
                    <label for="email">Email address</label>
                    <input type="email" name="email" id="email"
                           class="form-control @error('email') is-invalid @enderror" placeholder="Enter email"
                           value="{{ old('email') }}" required>
                    @error('email')
                    <span class="invalid-feedback" role="alert">
                        <strong>{{ $message }}</strong>
                    </span>
                    @enderror
                </div>

                {{-- TODO : gestion des erreurs --}}
                <div class="form-group">
                    <label>Rôle</label>
                    <select class="form-control" name="admin" id="admin">
                        <option value="0">Utilisateur</option>
                        <option value="1">Administrateur</option>
                    </select>
                </div>

                <label>Liste des capteurs non attribués</label>

                @foreach($probesUnassigned as $probe)

                    <div class="form-check">
                        <input type="checkbox" class="form-check-input" id="probes{{$probe->id}}" name='probes[]' value='{{$probe->id}}'>
                        <label class="form-check-label" for="probes{{$probe->id}}">Capteur #{{$probe->id}}</label>
                    </div>

                @endforeach

            </div>
            <!-- /.card-body -->

            <div class="card-footer">
                <button type="submit" class="btn btn-primary">Submit</button>
            </div>
        </form>
    </div>

@endsection

resources/views/probes/index.blade.php
@extends('layouts.app')

@section('content')
{{--    TODO : modal only for admin--}}

    <div class="card">
        <div class="card-header">
            <h3 class="card-title">Capteurs</h3>

            <div class="card-tools">
                <!-- Button trigger modal -->
                <button type="button" class="btn btn-primary btn-sm" data-toggle="modal"
                        data-target="#modal-create-probe">
                    Nouveau capteur
                </button>
            </div>
        </div>
        <!-- /.card-header -->
        <div class="card-body p-0">
            <table class="table">
                <thead>
                <tr>
                    <th style="width: 10px">#</th>
                    <th>Nom</th>
                    <th>Type</th>
                    <th>Connecté</th>
                    <th>Action</th>
                </tr>
                </thead>
                <tbody>

                @foreach($probes as $probe)

                    <tr>
                        <td>{{$probe->id}}</td>
                        <td>{{$probe->name}}</td>
                        <td>{{$probe->type}}</td>
                        <td>{{$probe->keepalive ? 'Oui' : 'Non'}}</td>
                        <td>
                            <div class="btn-group">
                                <a href="{{route('probes.show', $probe)}}" class="btn btn-default"><i class="fas fa-eye"></i></a>
                            </div>
                        </td>
                    </tr>

                @endforeach
                </tbody>
            </table>
        </div>
        <!-- /.card-body -->
    </div>

    <!-- Modal -->
    <div class="modal fade" id="modal-create-probe" tabindex="-1" role="dialog" aria-labelledby="modal-create-probe">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title">Créer un capteur</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">×</span>
                    </button>
                </div>
                <form action="{{route('probes.store')}}" method="post">
                    @csrf
                    <div class="modal-body">
                        <div class="form-group">
                            <label for="name">Nom</label>
                            <input type="text" class="form-control" name="name" id="name" placeholder="Entrer un nom">
                        </div>

                        <div class="form-group">
                            <label for="type">Type</label>
                            <input type="text" class="form-control" name="type" id="type" placeholder="Entrer un type">
                        </div>

                        <div class="form-check">
                            <input type="checkbox" class="form-check-input" name="add-test-data" id="add-test-data">
                            <label class="form-check-label" for="add-test-data">Insérer des données de test ?</label>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="submit" class="btn btn-primary">Créer</button>
                    </div>
                </form>
            </div>
        </div>
    </div>

@endsection

resources/views/probes/view.blade.php
@extends('layouts.app')

@section('content')

    <div class="row">

        <div class="col-12">
            <chart-component title="{{$probe->name}}" id="{{$probe->id}}"
                             keepalive="{{$probe->keepalive}}"></chart-component>
        </div>

    </div>
@endsection